This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 463320 - [LTC 6.0 FEAT] 201443:Support barrier synchronization facility in POWER5 and POWER6 CPUs
[LTC 6.0 FEAT] 201443:Support barrier synchronization facility in POWER5 and ...
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
6.0
ppc64 All
high Severity high
: alpha
: 6.0
Assigned To: Ameet Paranjape
Martin Jenner
: FutureFeature
Depends On:
Blocks: 356741 RHEL6Kernel2.6.27
  Show dependency treegraph
 
Reported: 2008-09-22 17:31 EDT by IBM Bug Proxy
Modified: 2010-10-18 10:26 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-12 18:20:59 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description IBM Bug Proxy 2008-09-22 17:31:03 EDT
=Comment: #0=================================================
Emily J. Ratliff <emilyr@us.ibm.com> - 2008-09-16 18:28 EDT
1. Feature Overview:
Feature Id:	[201443]
a. Name of Feature:	Support barrier synchronization facility in POWER5 and POWER6 CPUs
b. Feature Description
Kernel and library support for making the POWER5/6 barrier synchronization (BSR) facility available
to applications.  The BSR facility provides low-latency barrier synchronization, which is useful for
HPC and other multi-threaded applications that wish to wait until all threads have reached a certain
point in the program.  The kernel support will be a device driver for a /dev/bsr device (or
/dev/misc/bsr) which supports mmap and ioctl calls.  The ioctl call will be used to allocate a
section of the BSR facility, and mmap will be used to map the allocated BSR registers into
userspace.  A userspace library will provide an API similar to that provided by the AIX bsr_alloc,
bsr_query and bsr_free calls.

2. Feature Details:
Sponsor:	PPC
Architectures:
ppc64

Arch Specificity: Purely Arch Specific Code
Affects Core Kernel: Yes
Delivery Mechanism: Direct from community
Category:	Power
Request Type:	Kernel - Enhancement from IBM
d. Upstream Acceptance:	Accepted
Sponsor Priority	1
f. Severity: High
IBM Confidential:	no
Code Contribution:	IBM code
g. Component Version Target:	2.6.27

3. Business Case
HPC improvement. This will be needed for  parallel-processing applications so that the application
uses a BSR to perform barrier synchronization, which is a method for synchronizing the threads in
the parallel-processing application.

4. Primary contact at Red Hat: 
John Jarvis
jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Michael Hohnbaum, hbaum@us.ibm.com, 503-578-5486

Technical contact(s):
Paul Mackerras, pmac@au1.ibm.com

IBM Manager:
Pat Gaughen, gaughen@us.ibm.com
Comment 1 Bill Nottingham 2008-10-02 11:43:48 EDT
Is there a reason this isn't done via libc support in pthread_barrier_*?
Comment 2 IBM Bug Proxy 2008-10-15 12:21:26 EDT
pthread_barrier_* could use BSR, but with some major restrictions.

There is only one BSR per system and it has a limited size,

so it'd have to fall back on a normal implementation if

more than N threads used it (very tricky to detect that ahead of time

I think).

BSR is really too restrictive to be used in a general barrier

implementation like in the pthreads library.
Comment 3 Bill Nottingham 2008-10-15 12:57:01 EDT
Wouldn't this mean that the userspace library (or the app that called it) would have to do the exact same tests?
Comment 4 IBM Bug Proxy 2008-10-21 14:20:45 EDT
Yes, the library would have to acquire exclusive access to some or all of the BSR and fall back to a conventional barrier if it weren't available.  We're planning on using libbsr to handle exclusion for user's who want to access the BSR.  The expectation though it that on HPC machines there would be a single -- or at most a few apps -- which run at the same time, and there would not be heavy contention on the BSR in that environment.
Comment 5 IBM Bug Proxy 2009-03-02 16:11:08 EST
this is in 2.6.27
sha1 id: fe9e8d53772b5ea9ccf8ea4e8f0f009a6885eb70
Comment 6 Bill Nottingham 2009-03-03 17:22:09 EST
OK, marking as MODIFIED.

The feature requested has already been accepted into the upstream code base
planned for the next major release of Red Hat Enterprise Linux.

When the next milestone release of Red Hat Enterprise Linux 6 is available,
please verify that the feature requested is present and functioning as
desired.
Comment 7 Kevin W Monroe 2009-11-12 18:20:59 EST
Closing as support is available in current release.

Note You need to log in before you can comment on or make changes to this bug.